//  Name: Chess.java
//  Author: James Zheng Liang
//  Date: July 8, 1997 - July 23, 1997
//  Purpose: This controls the workings of the board and interacts with the Piece class
//  and board VRML file to run my 3D Chess game in a Tango enviornment

import java.net.*;
import tango.interfaces.AppletBase;
import tango.messages.*;
import tango.consts.*;

import java.awt.*;
import java.io.*;
import java.applet.*;
import java.util.*;
import vrml.external.field.*;
import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.exception.*;
import netscape.javascript.JSObject;
import Piece;
import Player;

public class Chess extends AppletBase {
  // enumerated names of my chess pieces
  public final static int W_KING	= 0;
  public final static int W_QUEEN	= 1;
  public final static int W_KNIGHT	= 2;
  public final static int W_ROOK	= 3;
  public final static int W_BISHOP	= 4;
  public final static int W_PAWN	= 5;
  public final static int B_KING	= 6;
  public final static int B_QUEEN	= 7;
  public final static int B_KNIGHT	= 8;
  public final static int B_ROOK	= 9;
  public final static int B_BISHOP	= 10;
  public final static int B_PAWN	= 11;
  public final static int W_SQUARE = 12;
  public final static int B_SQUARE = 13;
  
  // position of killed pieces
  private float white_x = 114f;
  private float white_y = 12f;
  private float black_x = -114f;
  private float black_y = -12f;

  // variables I added to allow for tango interaction
  private Frame f;
  private boolean caste = false;
  public String me = "Player";
  public boolean Master = false;
  private boolean ready = false;
  private boolean cont = false;
  private boolean initialized;
  private boolean owner = false;
  private int participants = 0;
  private int count = 0; // the number of chess Pieces I have - 1
  private int type = -2; 
  boolean isActive = false;
  TextArea output = null;
  Browser browser;
  Node material = null;
  EventInSFColor diffuseColor = null;
  EventOutSFColor outputColor = null;
  EventOutSFTime touchTime = null;
  boolean error = false;
  Piece current_Piece = null, From, To;
  Piece board[][] = null;
  Node root;
  Node reset;
  Piece Pieces[] = null;
  boolean created = false;
  boolean started = false;
  boolean smooth = false;
  private boolean Victory = false;
  private Player[] player;
  private boolean first;
  private int revive = 0;
  private Reset res = null;
  private int which_x = -1, which_y = -1, which_one = -1;
  private Node time;
  private EventOutSFTime current_Time;
  private boolean stats = false;
  private int number = 0;
  private boolean hasStarted = false;
  private boolean readjust = false;
  private int readjust_mode = 0;
  private listWindow listwindow;
  
  public void init() {
    register();
    initialized = false;
    System.out.println("                              Welcome to 3D Tango Chess                                     ");
    System.out.println("If you are having trouble with this game, you may want to check the requirement's page      ");
    System.out.println("at http://www.npac.syr.edu/REU/reu97/www/ce97jzl/req.html to make sure you have the plugins.");
    System.out.println("If difficulties persist, you can contact me directly for help at Liangjz@lore.cs.purdue.edu ");
    System.out.println("Thank you for taking interested in my game.                                                 ");
    System.out.println("                                                  James Zheng Liang                         ");
    setBackground(Color.black);
    setForeground(Color.white);
    output = new TextArea(5, 90);
    showStatus("Please wait while the chess board and pieces are created.");
    add("North",output);
    output.setEditable(false);
    output.appendText(
		      "                                                     <<<" + 
		      "Welcome to 3D Virtual Chess by James Liang" + 
		      ">>>                                                     " + "\n");
    JSObject win = JSObject.getWindow(this);
    JSObject doc = (JSObject) win.getMember("document");
    JSObject embeds = (JSObject) doc.getMember("embeds");
    browser = (Browser) embeds.getSlot(0);
    
    // get the data from the VRML file
    
    
    try {
      root = browser.getNode("ROOT");
      time = browser.getNode("TIME");
    }
    catch (InvalidNodeException e) {
      output.appendText("PROBLEM: "+ e + "\n");
      output.appendText("Please make sure you have a the a version of cosmo player that can handle eai" + "\n" +
			"You can find one at http://cosmo.sgi.com" + "\n");
    }
    current_Time = (EventOutSFTime) time.getEventOut("time");
    
    this.createBoard();
    this.createPieces();
    res = new Reset(this);
  }
  
  private void Send(String msg) {
    try {
      byte[] t = new byte[msg.length()];
      msg.getBytes(0,msg.length(),t,0);
      AppEventMessage em = new AppEventMessage(Const.DATA,t);
      send(em);
    }
    catch (Exception e) {e.printStackTrace();}
  }
  
  private void Send(double i) {
    String s = java.lang.Double.toString(i);
    Send(s);
  }

  public void receive(AppEventMessage em) {
    if (!initialized) {
      first = true;
      player = new Player[2];
      player[0] = new Player();
      player[1] = new Player();
      initialized = true;
      byte[] tab = new byte[1];
      tab[0] = CAConsts.USERNAME;
      CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
      send(mess); // request the user name;
    }
      
    if (em.getType() == Const.DATA) {
      boolean temp = true;
      String msg = new String(em.getData(),0,0,em.getLen());
      try {
	double Message = (java.lang.Double.valueOf(msg)).doubleValue();
	if ((Message > 0)&&(Message < 1))
	  this.resetBoard();
	if (Message == -17794123) {
	  participants = 0;
	  readjust = true;
	}
	if ((Message < 1)&&(Master == true))
	  if (Message >= 0)
	    this.resetBoard();
	  else 
	    if (player[0].ok == false) {
	      Send("Not ready for Transmittion");}
	    else {
	      System.out.println("Player information has been initialized");
	      player[1].ok = true;
	      player[1].isBlack = (!player[0].isBlack);
	      if (player[0].isBlack) {
		Send("Black");
		type = 1;
		output.appendText(player[1].name + " will go first." + "\n"); }
	      else {
		Send("White");
		type = 0;
		output.appendText("You may now begin." + "\n");}
	    }
	else {
	  if (Message < 1000000)
	    if ((Message < 3000)&&(created == true)) {
	      // must be a coordinate
	      Double I_Hate_Java = new Double(Message);
	      int n = I_Hate_Java.intValue();
	      which_one = (int)(n/1000)    -    (10 * (int)(n/10000));
	      which_x =   (int)(n/100)     -    (10 * (int)(n/1000));
	      which_y =   (int)(n/10)      -    (10 * (int)(n/100));
	      if (which_one == 1)
		this.tryCurrent(board[which_x][which_y].where, this.current_Time.getValue());
	      if (which_one == 2)
		this.tryCurrent(board[which_x][which_y], this.current_Time.getValue());
	    }
	    else 
	      if (participants == -3) {
		Double I_Hate_Java = new Double(Message);
		int n = I_Hate_Java.intValue() - 500000;
		which_one = (int)(n/1000);
		which_x =   (int)(n/100)     -    (10 * (int)(n/1000));
		which_y =   (int)(n/10)      -    (10 * (int)(n/100));
		int temporary = type;
		type = -1;
		if (which_x == 9) {
		  Pieces[which_one].where.where = null;
		  Pieces[which_one] = this.killPiece(Pieces[which_one], this.current_Time.getValue());
		}
		else
		  this.movePiece(Pieces[which_one], board[which_x][which_y], 0);
		type = temporary;
		Pieces[which_one].moved = true;
	      } 
	}
      }
      catch (NumberFormatException e) {temp = false;}
      
      if (temp == false) {
	isActive = false;
	if ((readjust == true)&&(Master == false)) 
	  this.reAdjust(msg);
	else {
	  if (current_Piece != null) 
	    this.setColor(current_Piece);
	  if (msg.equals("Ok, for this game, you are nothing more than an observer.  You can't participate.")) {
	    if ((stats == false)||(participants == -3))    
	      participants = -3;
	  }
	  else 
	    if (msg.equals("Master will go now...........")) {
	      if (participants == -3)
		type = 0;
	    }
	    else
	      if (msg.equals("The Slave must now go!!!!!!!!")) {
		if (participants == -3)
		  type = 1;
	      }
	      else {
		if (msg.equals("Black")) {
		  if (hasStarted == false) { 
		    hasStarted = true;
		    if (participants != -3) {
		      type = 0;
		      player[1].isBlack = true;
		      player[0].isBlack = false;
		      output.appendText(player[0].name +", you may now begin." + "\n");
		    }
		    else {
		      type = 1;
		      player[0].isBlack = true;
		      player[1].isBlack = false;
		    }
		    System.out.println("Player information has been initialized");
		    player[0].ok = player[1].ok = true;
		  }
		}
		else
		  if (msg.equals("White")) {
		    if (hasStarted == false) {
		      hasStarted = true;
		      if (participants != -3) {
			output.appendText(player[1].name + " will go first." + "\n");
			player[1].isBlack = false;
			player[0].isBlack = true;
			type = 1;
		      }
		      else {
			type = 0;
			player[0].isBlack = false;
			player[1].isBlack = true;
		      }
		      System.out.println("Player information has been initialized");
		      player[0].ok = player[1].ok = true;
		    }
		  }
		  else
		    if (msg.equals("Not ready for Transmittion")) {
		      if ((participants != -3)
			  &&(player[1].name.equals(
						   "No name has been assigned to this particular player as of yet in this session of Tango Chess by James Z. Liang"
						   ) == false)) {
			Send(-9.47);
		      }
		    }
		    else {
		      if ((Master == true)&&(participants > 2)) {
			output.appendText(msg + " has joined as an observer." +"\n");
			Send("Ok, for this game, you are nothing more than an observer.  You can't participate.");
			Send(player[0].name);
			Send(player[1].name);
			if (player[0].ok == true)
			  if (player[0].isBlack) 
			    Send("Black");
			  else 
			    Send("White");
			for (int ii = 0; 32 > ii; ii++){ 
			  if (Pieces[ii].moved == true) 
			    Send((double)(5 + 10 * Pieces[ii].yang + 100 * Pieces[ii].xang + 1000 * ii +500000));
			}
			if (player[0].ok == true) {
			  if (type == 0)
			    Send("Master will go now...........");
			  if (type == 1)
			    Send("The Slave must now go!!!!!!!!");
			}
		      }
		      else {
			if (participants == -3) {
			  if (stats == false) {
			    player[number].name = msg;
			    number++;
			    if (number > 1) {
			      output.appendText("You are the observer of this game between " + 
						player[0].name + " and " + 
						player[1].name + "." +
						"\n");
			      stats = true;
			    }
			  }
			}
			if (((stats == false)&&(participants != -3))||(Master == true)) {
			  player[1].name = msg;
			  stats = true;
			}
			if (Master == true) {
			  Send(player[0].name);
			  if (player[0].ok == false)
			    Send("Not ready for Transmittion");
			  else { 
			    player[1].isBlack = (!player[0].isBlack);
			    player[1].ok = true;
			    if (player[0].isBlack) {
			      Send("Black");
			      type = 1;
			      output.appendText(player[1].name + " is ready to go." + "\n"); }
			    else {
			      Send("White");
			      type = 0;
			      output.appendText(player[1].name + " has joined the game, you may now begin" + "\n");
			    }
			  }
			}
		      }
		      
		    }
	      }
	}
	ready = true;
      }
    }
    else {
      CAppAnswerEventMessage msg = (CAppAnswerEventMessage)em;
      if (msg.getAnswerType() == CAConsts.ISMASTER) {
	Master = msg.isMaster();
	if (Master) {
	  System.out.println("You are the master!!");
	  participants = 1;
	  stats = true;
	  if (caste == true) {
	    readjust = true;
	    type = -1;
	    byte tab[] = new byte[1];
	    tab[0] = CAConsts.PARTICIPANTS;
	    CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
	    send(mess); //Sending request for participants to Control Application
	  }
	  else
	    caste = true;
	}
	else {
	  stats = false;
	  participants = 0;
	  System.out.println("You are a slave!!");
	  if (caste == true) {
	    type = -1;
	    readjust = true;
	  }
	  else
	    caste = true;
	}
	cont = true;
      }
      if ((msg.getAnswerType() == CAConsts.PARTICIPANTS)&&(Master == true)) {
	Vector v = msg.getParticipants();
	participants = v.size();
	if (readjust == false) {
	  if (player[1].name.equals(
"No name has been assigned to this particular player as of yet in this session of Tango Chess by James Z. Liang"))
	    System.out.println("A new participant joined this chess session");
	  else 
	    if (v.size() > 1) {
	      boolean testing = false;
	      for (int i = 0; i < v.size(); i++) {
		if (player[1].name.equals(v.elementAt(i)))
		  testing = true;
	      }
	      if (testing)
		System.out.println("A new participant joined this chess session");
	      else {
		type = -2;
		output.appendText(player[1].name + " has left the game." + "\n");
		player[1].name = 
		  "No name has been assigned to this particular player as of yet in this session of Tango Chess by James Z. Liang";
		Send(-17794123);
		readjust = true;
		type = -1;
		byte tab[] = new byte[1];
		tab[0] = CAConsts.PARTICIPANTS;
		CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
		send(mess); //Sending request for participants to Control Application
	      }
	    }
	    else {
	      type = -2;
	      output.appendText(player[1].name + " has left the game." + "\n");
	      player[1].name = 
		"No name has been assigned to this particular player as of yet in this session of Tango Chess by James Z. Liang";
	      this.resetBoard();
	    }
	}
	else {
	  if (v.size() < 3) {
	    Send(player[1].name);
	    Send(player[0].name);
	    this.resetBoard();
	  }
	  else 
	    this.getNewOpponent(v);
	}
      }
      if (msg.getAnswerType() == CAConsts.USERNAME) {
	me = msg.getUsername();
	player[0].name = me;
      }
      if ((created == true)&&(started == false)) {
	if ((me != "Player")&&(cont == true)) {
	  player[0].name = me;
	  if (Master)
	    player[0].getType();
	  else {
	    Send(player[0].name);
	  }
	  started = true; player[1].isBlack = false;
		    player[0].isBlack = true;
	}
      }
    }
  }

  private void reAdjust(String ss) {
    if (Master != true) { 
      if (readjust_mode == 0) {
	readjust_mode = 1;
	if (ss.equals(me))
	  player[0].name = me;
	else {
	  player[1].name = ss;
	  participants = -3;
	}
      }
      else {
	if (readjust_mode == 1) {
	  readjust_mode = 0;
	  readjust = false;
	  if (participants != -3) {
	    player[1].name = ss;
	    output.appendText("You have been challenged by " + ss + "." +"\n");
	  }
	  else {
	    player[0].name = ss;
	    output.appendText("You are the observer of a game between " + 
			      player[0].name + " and " +  player[1].name 
			      + "." + "\n");
	  }
	}
      }
    }
  }
  
  private void getNewOpponent(Vector v) {
    listwindow = new listWindow(this, v);
    f = new Frame("Choose your opponent");
    f.setLayout(new GridLayout(1,1));
    f.resize(253,90);
    f.add(listwindow);
    f.show();
  }
  
  public void selectOpponent(String opponentName) {
    f.hide();
    player[0].name = me;
    player[1].name = opponentName;
    Send(opponentName);
    Send(player[0].name);
    this.resetBoard();
    readjust = false;
    listwindow = null;
    output.appendText("Starting game between " + player[0].name + " and " + player[1].name + "." + "\n");
  }
  
  private String NamePiece(Piece t) {
    if (t.Type() == W_KING) 
      return "White King";
    if (t.Type() == W_QUEEN) 
      return "White Queen";
    if (t.Type() == W_BISHOP) 
      return "White Bishop";
    if (t.Type() == W_KNIGHT) 
      return "White Knight";
    if (t.Type() == W_ROOK) 
      return "White Rook";
    if (t.Type() == W_PAWN) 
      return "White Pawn";
    if (t.Type() == B_KING) 
      return "Black King";
    if (t.Type() == B_QUEEN) 
      return "Black Queen";
    if (t.Type() == B_BISHOP) 
      return "Black Bishop";
    if (t.Type() == B_KNIGHT) 
      return "Black Knight";
    if (t.Type() == B_ROOK) 
      return "Black Rook";
    if (t.Type() == B_PAWN) 
      return "Black Pawn";
    return "";
  }
  
  private Piece killPiece(Piece dead, double ti) {
    dead.killed = true;
    dead.xang = 9;
    boolean ok = false;
    float[] ff = new float[3];
    if ((dead.Type() == W_KING)||(dead.Type() == B_KING))
      Victory = true;
    if ((dead.Type() >= 6)&&(dead.Type() < 12)) {
      // kill black piece
      this.smoothTranslation(ti, white_x, dead.z, white_y, dead);
      if (white_y + 24f > 84f) {
	white_x = white_x +24f;
	white_y = 12f;
      }
      else
	white_y = white_y + 24f;
    }
    if ((dead.Type() >= 0)&&(dead.Type() < 6)) {
      // kill white piece
      this.smoothTranslation(ti, black_x, dead.z, black_y, dead);
      if (black_y - 24f < -84f) {
	black_x = black_x - 24f;
	black_y = -12f;
      }
      else
	black_y = black_y - 24f;
    }
    return dead;
  }
  
  private void victory() {
    if ((type == 1)||(participants == -3)) {
      output.appendText("Checkmate: " + player[type].name + " Wins!!" + "\n");
      showStatus("Checkmate: " + player[type].name + " Wins!!");
    }
    if ((type == 0)&&(participants != -3)) {
      output.appendText("Checkmate: You Win!!" + "\n");
      showStatus("Checkmate: You Win!!");
    }
    type = -1;
  }
  
  private void createBoard() {
    boolean black = true;
    float x = -84f;
    board = new Piece[8][8];
    for (int i = 0; i < 8; i++) {
      float y = -84f;
      for (int j = 0; j <8; j++) {
	if (black = !black)
	  board[i][j] = new Piece(this, Chess.B_SQUARE, x, y,i,j);
	else
	  board[i][j] = new Piece(this, Chess.W_SQUARE, x, y,i,j);
	board[i][j] = this.setTranslation(board[i][j], x, 0f, y);
	this.add(board[i][j]);
	y = y + 24f;
      }
      black = !black;
      x = x + 24f;
    }
  }

  private String NameSquare(int x, int y) {
    String V = String.valueOf(8 - y);
    if (x == 0)
      return "a" + V;
    if (x == 1)
      return "b" + V;
    if (x == 2)
      return "c" + V;
    if (x == 3)
      return "d" + V;
    if (x == 4)
      return "e" + V;
    if (x == 5)
      return "f" + V;
    if (x == 6)
      return "g" + V;
    if (x == 7)
      return "h" + V;
    return "";
  }

  private void setScale(Piece n) {
    if ((n.Type() != W_SQUARE)&&(n.Type() != B_SQUARE)) {
      float val[] = new float[3];
      if ((n.Type() == W_KING)||(n.Type()== B_KING))
	val[0] = val[1] = val[2] = n.kingScale;
      if ((n.Type()== W_QUEEN)||(n.Type()== B_QUEEN))
	val[0] = val[1] = val[2] = n.queenScale;
      if ((n.Type()== W_BISHOP)||(n.Type()== B_BISHOP))
	val[0] = val[1] = val[2] = n.bishopScale;
      if ((n.Type()== W_KNIGHT)||(n.Type()== B_KNIGHT))
	val[0] = val[1] = val[2] = n.knightScale;
      if ((n.Type()== W_ROOK)||(n.Type()== B_ROOK))
	val[0] = val[1] = val[2] = n.rookScale;
      if ((n.Type()== W_PAWN)||(n.Type()== B_PAWN))
	val[0] = val[1] = val[2] = n.pawnScale;
      current_Piece.set_scale.setValue(val);
    }
  } 
  
  private void setRotation(Piece n) {
    if ((n.Type() == W_KING)||(n.Type() == B_KING)) {
      float val[] = new float[4];
      val[0] = 0f;
      val[1] = 1f;
      val[2] = 0f;
      val[3] = 1.2f;
      current_Piece.set_rotation.setValue(val); 
    }
    if (n.Type() == W_KNIGHT) {
      float val[] = new float[4];
      val[0] = 0f;
      val[1] = 1f;
      val[2] = 0f;
      val[3] = -3.1416f;
      current_Piece.set_rotation.setValue(val);
    }
  }
  
  private Piece setTranslation(Piece newPiece, float x, float y, float z) {
    float val[] = new float[3];
    newPiece.x = val[0] = x;
    newPiece.z = val[1] = y;
    newPiece.y = val[2] = z;
    newPiece.set_translation.setValue(val);
    return newPiece;
  }
  
  private void smoothTranslation(double ti, float x, float y, float z, Piece e) { e.smoothTranslation(x,y,z,ti); } 
  
  private void createPieces() {
    Pieces = new Piece[32];
    Piece newPiece = null;
    if (created == false) {
      // white king
      newPiece = new Piece(this, Chess.W_KING, board[4][7], 0f, 0);
      newPiece = this.setTranslation(newPiece, 12f, 0f, 84f);
      add(newPiece);
      
      // black king
      newPiece = new Piece(this, Chess.B_KING, board[4][0], 0f, 1);
      newPiece = this.setTranslation(newPiece, 12f, 0f, -84f);
      add(newPiece);
      
      // white queen
      newPiece = new Piece(this, Chess.W_QUEEN, board[3][7], 0f, 2);
      newPiece = this.setTranslation(newPiece, -12f, 0f, 84f);
      add(newPiece);
      
      // black queen
      newPiece = new Piece(this, Chess.B_QUEEN, board[3][0], 0f, 3);
      newPiece = this.setTranslation(newPiece, -12f, 0f, -84f);
      add(newPiece);
      
      // white bishop #1
      newPiece = new Piece(this, Chess.W_BISHOP, board[2][7], 0f, 4);
      newPiece = this.setTranslation(newPiece, -36f, 0f, 84f);
      add(newPiece);
      
      // black bishop #1
      newPiece = new Piece(this, Chess.B_BISHOP, board[2][0], 0f, 5);
      newPiece = this.setTranslation(newPiece, -36f, 0f, -84f);
      add(newPiece);
      
      // white bishop #2
      newPiece = new Piece(this, Chess.W_BISHOP, board[5][7], 0f, 6);
      newPiece = this.setTranslation(newPiece, 36f, 0f, 84f);
      add(newPiece);
      
      // black bishop #2
      newPiece = new Piece(this, Chess.B_BISHOP, board[5][0], 0f, 7);
      newPiece = this.setTranslation(newPiece, 36f, 0f, -84f);
      add(newPiece);
      
      // white knight #1
      newPiece = new Piece(this, Chess.W_KNIGHT, board[1][7], 0f, 8);
      newPiece = this.setTranslation(newPiece, -60f, 0f, 84f); 
      add(newPiece);
      
      // black knight #1
      newPiece = new Piece(this, Chess.B_KNIGHT, board[1][0], 0f, 9);
      newPiece = this.setTranslation(newPiece, -60f, 0f, -84f);
      add(newPiece);
      
      // white knight #2
      newPiece = new Piece(this, Chess.W_KNIGHT, board[6][7], 0f, 10);
      newPiece = this.setTranslation(newPiece, 60f, 0f, 84f); 
      add(newPiece);
      
      // black knight #2
      newPiece = new Piece(this, Chess.B_KNIGHT, board[6][0], 0f, 11);
      newPiece = this.setTranslation(newPiece, 60f, 0f, -84f);
      add(newPiece);
      
      // white rook #1
      newPiece = new Piece(this, Chess.W_ROOK, board[0][7], 0f, 12);
      newPiece = this.setTranslation(newPiece, -84f, 0f, 84f);
      add(newPiece);
      
      // black rook #1
      newPiece = new Piece(this, Chess.B_ROOK, board[0][0], 0f, 13);
      newPiece = this.setTranslation(newPiece, -84f, 0f, -84f);
      add(newPiece);
      
      // whiterook #2
      newPiece = new Piece(this, Chess.W_ROOK, board[7][7], 0f, 14);
      newPiece = this.setTranslation(newPiece, 84f, 0f, 84f);
      add(newPiece);
      
      // black rook #2
      newPiece = new Piece(this, Chess.B_ROOK, board[7][0], 0f, 15);
      newPiece = this.setTranslation(newPiece, 84f, 0f, -84f);
      add(newPiece);
      
      int temp = 15;
      float trnas[] = {-84f, -60f, -36f, -12f, 12f, 36f, 60f, 84f};
      for (int i = 0; 8 > i; i++) {
	// white pawn 
	temp++;
	newPiece = new Piece(this, Chess.W_PAWN, board[i][6], 0f, temp);
	newPiece = this.setTranslation(newPiece, trnas[i], 0f, 60f);
	add(newPiece);
	
	// black pawn
	temp++;
	newPiece = new Piece(this, Chess.B_PAWN, board[i][1], 0f, temp);
	newPiece = this.setTranslation(newPiece, trnas[i], 0f, -60f);
	add(newPiece);
      }
    }
    created = true;
    if (started == false) {
      if ((me != "Player")&&(cont == true)) {
	player[0].name = me;
	if (Master)
	  player[0].getType();
	else {
	  Send(player[0].name);
	}
	started = true;
      }
    }
  }
  
  public void resetBoard() {
    output.appendText("Restarting Game..." + "\n" + "\n");
    type = -1;
    isActive = false;
    this.setColor(current_Piece);
    player[0].ok = false;
    player[1].ok = false;
    if (Master == true) {
      player[0].getType();
      owner = false;
      Send(0.55);
    }
    else
      if (participants != -3)
	Send(-9.47);
    hasStarted = false;
    white_x = 114f;
    white_y = 12f;
    black_x = -114f;
    black_y = -12f;
    // white king
    this.movePiece(Pieces[0], board[4][7],0);
    // black king
    this.movePiece(Pieces[1], board[4][0],0);
    // white queen
    this.movePiece(Pieces[2], board[3][7],0);
    // black queen
    this.movePiece(Pieces[3], board[3][0],0);
    // white bishop #1
    this.movePiece(Pieces[4], board[2][7],0);
    // black bishop #1
    this.movePiece(Pieces[5], board[2][0],0);
    // white bishop #2
    this.movePiece(Pieces[6], board[5][7],0);
    // black bishop #2
    this.movePiece(Pieces[7], board[5][0],0);
    // white knight #1
    this.movePiece(Pieces[8], board[1][7],0);
    // black knight #1
    this.movePiece(Pieces[9], board[1][0],0);
    // white knight #2
    this.movePiece(Pieces[10], board[6][7],0);
    // black knight #2
    this.movePiece(Pieces[11], board[6][0],0);
    // white rook #1
    this.movePiece(Pieces[12], board[0][7],0);
    // black rook #1
    this.movePiece(Pieces[13], board[0][0],0);
    // white rook #2
    this.movePiece(Pieces[14], board[7][7],0);
    // black rook #2
    this.movePiece(Pieces[15], board[7][0],0); 
    int num = 0;
    for (int i = 0; 8 > i; i++) {
      // white pawn
      ++num;
      this.movePiece(Pieces[15 + num], board[i][6],0);
      // black pawn
      ++num;
      this.movePiece(Pieces[15 + num], board[i][1],0);
    }
    type = -2;
    Victory = false;
    for (int i = 0; 32 > i; i++) {
      Pieces[i].killed = false;
      Pieces[i].moved = false;
    }
  }
  
  
  private void add(Piece newPiece) {
    current_Piece = newPiece;
    if (Pieces != null) {
      Pieces[count] = current_Piece;
      count++;
    }
    if ((newPiece.Type() == W_SQUARE)||(newPiece.Type() == B_SQUARE)) {
      try {
	EventInMFNode addChildren = 
	  (EventInMFNode) root.getEventIn("addChildren");
	addChildren.setValue(current_Piece.transArray);
      }
      catch (InvalidEventInException ea) {
	output.appendText("Problem: " + ea + "\n" +
                          "Please make sure you have to most recent version of cosmo player" + "\n" +
                          "You can find one at http://cosmo.sgi.com" + "\n");
      }
    }
    this.setRotation(current_Piece);
    this.setScale(current_Piece);
    this.setColor(current_Piece);
  }
  
  private boolean isSame(Piece a, Piece b) {
    if ((a.Type() >= 6)&&(a.Type() < 12)) {
      if ((b.Type() >= 6)&&(b.Type() < 12)) 
	return true;  
      else
	return false;
    }
    if ((a.Type() >= 0)&&(a.Type() < 6)) {
      if ((b.Type() >= 0)&&(b.Type() < 6))  
	return true; 
      else
	return false;
    }
    return false;
  }

  private boolean checkDiagonal(Piece from, Piece to) {
    int y_value = from.yang; 
    for (int i = from.xang + (to.xang - from.xang)/Math.abs(to.xang - from.xang); i != to.xang; 
	 i += (to.xang - from.xang)/Math.abs(to.xang - from.xang)) {
      y_value = y_value +  (to.yang - from.yang)/Math.abs(to.yang - from.yang);
      if(board[i][y_value].where != null)
	return false;
    }
    return true;
  }
  
  private boolean checkStraight(Piece from, Piece to) {
    if (to.yang - from.yang == 0) {
      for (int i = from.xang + (to.xang - from.xang)/Math.abs(to.xang - from.xang); i != to.xang; 
	   i += (to.xang - from.xang)/Math.abs(to.xang - from.xang))
	if(board[i][to.yang].where != null)
	  return false;
      return true;
    } 
    if  (to.xang - from.xang == 0) {
      for (int i = from.yang + (to.yang - from.yang)/Math.abs(to.yang - from.yang); i != to.yang;
	  i = i + (to.yang - from.yang)/Math.abs(to.yang - from.yang))
	if(board[to.xang][i].where != null)
	  return false;
	  return true;
    }
    return false;
  }
  
  private boolean isValid(Piece from, Piece to, double ti) {
    if ((type == -1)||(type == -2))
      return true;
    if ((current_Piece.Type() == W_KING)&&(current_Piece.moved == false)) {
      if ((to == board[2][7])&&(board[0][7].where.moved == false)) {
	this.movePiece(board[0][7].where, board[3][7], ti); 
	output.appendText(player[type].name + ": White King castle to Queen's side." + "\n"); 
	return true;
      }
      if ((to == board[6][7])&&(board[7][7].where.moved == false)) {
	this.movePiece(board[7][7].where, board[5][7], ti); 
	output.appendText(player[type].name + ": White King castle to King's side." + "\n");
	return true;
      }
    }
    if ((current_Piece.Type() == B_KING)&&(current_Piece.moved == false)) {
      if ((to == board[2][0])&&(board[0][0].where.moved == false)) {
	this.movePiece(board[0][0].where, board[3][0], ti);
	output.appendText(player[type].name + ": Black King castle to Queen's side." + "\n");
	return true; 
      }
      if ((to == board[6][0])&&(board[7][0].where.moved == false)) {
	this.movePiece(board[7][0].where, board[5][0], ti);
	output.appendText(player[type].name + ": Black King castle to King's side." + "\n");
	return true;
      }
    }
    if ((from.Type() == W_KING)||(from.Type() == B_KING)) {
      if ((Math.abs(to.xang - from.xang) <= 1)&&(Math.abs(to.yang - from.yang) <= 1)) {
	output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	return true;
      }
      else {
	output.appendText("You can't move there!" + "\n");
	return false;
      }
    }
    if ((from.Type() == W_QUEEN)||(from.Type() == B_QUEEN)) {
      if ( (Math.abs(to.xang - from.xang) == Math.abs(to.yang - from.yang)) ||
	   (Math.abs(to.yang - from.yang) == 0) ||  (Math.abs(to.xang - from.xang ) == 0)) 
	if ((Math.abs(to.yang - from.yang) == 1)||(Math.abs(to.xang - from.xang ) == 1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else
	  if (checkStraight(from,to)) {
	    output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	    return true;
	  }
	  else
	    if (checkDiagonal(from,to)) {
	      output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	      return true;
	    }
      output.appendText(player[type].name + ", you can't move there!" + "\n");
      return false;
    }
    if ((from.Type() == W_BISHOP)||(from.Type() == B_BISHOP)){
      if (Math.abs(to.xang - from.xang) == Math.abs(to.yang - from.yang))
	if ((Math.abs(to.xang - from.xang) <= 1)&&(Math.abs(to.yang - from.yang) <= 1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else
	  if (checkDiagonal(from, to)) {
	    output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	    return true;
	  }
      output.appendText(player[type].name + ", you can't move there!" + "\n");
      return false;
    }
    if ((from.Type() == W_ROOK)||(from.Type() == B_ROOK)){
      if ((Math.abs(to.yang - from.yang) == 0)||(Math.abs(to.xang - from.xang ) == 0))
	if ((Math.abs(to.xang - from.xang) <= 1)&&(Math.abs(to.yang - from.yang) <= 1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else
	  if (checkStraight(from, to)) {
	    output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	    return true;
	  }
      output.appendText(player[type].name + ", you can't move there!" + "\n");
      return false;
    }
    if ((from.Type() == W_KNIGHT)||(from.Type() == B_KNIGHT)){
      if ((Math.abs(to.xang - from.xang) == 1)&&(Math.abs(to.yang - from.yang) == 2)) {
	output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	return true;
      }
      else
	if ((Math.abs(to.xang - from.xang) == 2)&&(Math.abs(to.yang - from.yang) == 1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else {
	  output.appendText(player[type].name + ", you can't move there!" + "\n");
	  return false;
	}
    }
    if (from.Type() == W_PAWN) {
      if (from.moved == false) 
	if ((Math.abs(to.xang - from.xang) == 0)&&(to.yang - from.yang >= -2))
	  if (this.checkStraight(from, to)) {
	    output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	    return true;
	  }
	  else {
		output.appendText(player[type].name + ", you can't move there!" + "\n");
		return false;
	  }
      if (to.where != null)
	if ((Math.abs(to.xang - from.xang) == 1)&&(to.yang - from.yang == -1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else {
	  output.appendText(player[type].name + ", you can't move there!" + "\n");
	  return false;
	}
      else
	if ((Math.abs(to.xang - from.xang) == 0)&&(to.yang - from.yang == -1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else {
	  output.appendText(player[type].name + ", you can't move there!" + "\n");
	  return false;
	}
    }
    if (from.Type() == B_PAWN) {
      if (from.moved == false) 
	if ((Math.abs(to.xang - from.xang) == 0)&&(to.yang - from.yang == 2))
	  if (this.checkStraight(from, to)) {
	    output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	    return true;
	  }
	  else {
	    output.appendText(player[type].name + ", you can't move there!" + "\n");
	    return false;
	  }
      if (to.where != null)
	if ((Math.abs(to.xang - from.xang) == 1)&&(to.yang - from.yang == 1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else {
	  output.appendText(player[type].name + ", you can't move there!" + "\n");
	  return false;
	}
      else
	if ((Math.abs(to.xang - from.xang) == 0)&&(to.yang - from.yang == 1)) {
	  output.appendText(player[type].name + ": " + this.NamePiece(from) + " from " + this.NameSquare(from.xang, from.yang)+ " to " + this.NameSquare(to.xang, to.yang) + "." + "\n");
	  return true;
	}
	else {
	  output.appendText(player[type].name + ", you can't move there!" + "\n");
	  return false;
	}
    }
    return false;
  }
  
  private boolean movePiece(Piece from, Piece to, double ti) {
    boolean temp = true;
    boolean MOVE = true;
    if ((this.isValid(from, to, ti) == false)&&(type != -1)) 
      return false;
    if ((to.where != null)&&(type != -1)) {
      if (this.isSame(to.where, from)) {
	MOVE = false; 
	output.appendText(player[type].name + ", you can't move there!" + "\n"); 
	return false;
      }
      else {
	output.appendText("   " + this.NamePiece(from) + " takes " + this.NamePiece(to.where) + "." + "\n");
	to.where = this.killPiece(to.where, ti); 
      }
    }
    if (MOVE) {
      from.moved = true;
      if (type == -1)
	from = this.setTranslation(from, to.x, from.z, to.y);
      else 
	if ( ((current_Piece.Type() == W_PAWN)&&(to.y == -84f)) || ((current_Piece.Type() == B_PAWN)&&(to.y == 84f))) {
	  to.where = null; 
	  this.killPiece(from, ti);
	  output.appendText(player[type].name + " may now choose a dead piece to replace your pawn" + "\n");
	  revive++;
	  MOVE = false;
	  return false;
	}
	else 
	  this.smoothTranslation(ti, to.x, from.z, to.y, from);
      if (from.where != null)
	if (from.where.where != null)
	  from.where.where = null;
      if (MOVE) {
	to.where = from;
	from.where = to;
	from.xang = to.xang;
	from.yang = to.yang;
      }
    }
    return true;
  }
  
  private void Switch () {
    if (type == 0)
      type = 1;
    else
      if (type == 1)
	type = 0;
  }
  
  public boolean makeCurrent(Piece which) {
    if (participants == -3) {
      output.appendText("You are just an observer.  If you wish to play, start you own game or become the master of this one." + "\n");
      return false;
    }
    if (type == -1) {
      output.appendText("There is no game is session" + "\n");
      return false;
    }
    if (type == -2) {
      if ((Master == true)&&(player[0].ok == false))
	output.appendText("You have to choose black or white before we can begin" + "\n");
      else
	output.appendText("We need to wait until the other player is ready..." + "\n");
      return false;
    }
    if (type == 1) {
      output.appendText(player[0].name + ", it is not your turn!" + "\n");
      return false; 
    }
    if ((which.Type() == B_SQUARE)||(which.Type() == W_SQUARE))
      Send((double)(5 + 10 * which.yang + 100 * which.xang + 2000));
    else
      Send((double)(5 + 10 * which.yang + 100 * which.xang + 1000));
    return this.tryCurrent(which, this.current_Time.getValue());
  }
  
  
  private boolean tryCurrent(Piece which, double ti) {
    if (which.killed == true)
      if (revive > 0) {
	revive--; 
	which.killed = false;
      }
      else {
	output.appendText("That piece is dead." + "\n");
	return false;
      }
 
    if ((isActive)&&(which != current_Piece)) {
      if ((which.Type() == W_SQUARE)||(which.Type() == B_SQUARE)) {
	// will now move current_Piece
	if (type == -2)
	  output.appendText("There is no game in session!!");
	else {
	  if (this.movePiece(current_Piece, which, ti) == true) {
	    if (Victory) {
	      this.victory(); 
	      return true;
	    }	    
	    this.Switch();
	  }
	}
	this.setColor(current_Piece);
      }
      else {
	if ((this.isSame(which, current_Piece) == false)&&(current_Piece.Type() != W_SQUARE)&&(current_Piece.Type() != B_SQUARE)) {
	  // will now move current_Piece
	  if (type == -1)
	    output.appendText("There is no game in session!!");
	  else {
	    if (this.movePiece(current_Piece, which.where, ti) == true) {
	      if (Victory) {
		this.victory();
		return true;
	      }
	      this.Switch();
	    }
	  }     
	  this.setColor(current_Piece);
	}
	else {
	  isActive = false;
	  this.setColor(current_Piece);
	}
      }
    }
    current_Piece = which;
    
    if (isActive) {
      isActive = false;
      this.setColor(which);
    }
    else {
      boolean temp;
      if ((which.Type() != W_SQUARE)&&(which.Type() != B_SQUARE)) {
	if (player[type].isBlack)
	  if (this.isSame(Pieces[3],current_Piece))
	    temp = true;
	  else
	    temp = false;
	else
	  if (this.isSame(Pieces[2],current_Piece))
	    temp = true;
	  else
	    temp = false;
	if (temp) {
	  isActive = true;
	  this.hotColor(which);
	}
	else 
	  if (type == 0) {
	    this.Switch();
	    output.appendText(player[0].name + ", that is a " + this.NamePiece(which) + ".  You are touching the wrong piece!" + "\n");
	    this.Switch();
	  }
      }
    }
    return true;
  }
  
  public Browser getBrowser() {
    return browser;
  }
  
  private void setColor(Piece which) {
    float val[] = new float[3];
    float Val[] = new float[3];
    float VAL[] = new float[1];
    if ((which.Type() >= 6)&&(which.Type() < 12)) {
      // change to normal black piece color .25 .25 .35
      val[0] = .25f;  Val[0] = Val[1] = Val[2] = .6f;
      val[1] = .25f;  VAL[0] = .7f;
      val[2] = .35f;
    }
    if ((which.Type() >= 0)&&(which.Type() < 6)) {
      // change to normal white piece color .8 .8 .6
      val[0] = .8f;   Val[0] = Val[1] = Val[2] = 1f;
      val[1] = .8f;   VAL[0] = .7f;
      val[2] = .6f;
    }
    if (which.Type() == W_SQUARE) {
      // change to normal white square color
      val[0] = 1f;  Val[0] = Val[1] = Val[2] = .9f;
      val[1] = 1f;  VAL[0] = .95f;
      val[2] = 1f;
    }
    if (which.Type() == B_SQUARE) {
      // change to normal black square color
      Val[0] = 0.4f;  val[0] = val[1] = val[2] = 0.1f;  
      Val[1] = 0.2f;  VAL[0] = 0.95f;
      Val[2] = 0.2f;
    }
    current_Piece.set_diffuseColor.setValue(val);
    current_Piece.set_specularColor.setValue(Val);
    //current_Piece.set_shininess.setValue(VAL);
  }

  
  
  private void hotColor(Piece which) {
    float val[] = new float[3];
    if ((which.Type() >= 6)&&(which.Type() < 12)) {
      // change to selcted black piece color .4 .4 .3
      val[0] = .4f;
      val[1] = .4f;
      val[2] = .3f;
      current_Piece.set_diffuseColor.setValue(val);	  
    }
    if ((which.Type() >= 0)&&(which.Type() < 6)) {
      // change to selected white piece color 1 1 1
      val[0] = 1f;
      val[1] = 1f;
      val[2] = 1f;
      current_Piece.set_diffuseColor.setValue(val);	  
    } 
  }
}
class Reset extends Object implements EventOutObserver {
  public EventOutSFTime touchTime_changed;
  private Chess parent = null;
  Browser browser;
  
  public Reset (Chess myparent) {
    parent = myparent;
    Node reset;
    browser = parent.getBrowser();
    try {
      reset =  browser.getNode("TEXTTOUCH");
      touchTime_changed =
	(EventOutSFTime) reset.getEventOut("touchTime");
      
      touchTime_changed.advise(this, null);
    }
    catch (InvalidNodeException e) {
      parent.output.appendText("Problem: "+ e + "\n" +
			       "Please make sure you have a eai capable VRML browser." + "\n" +
			       "You can get a copy of a really good one at http://cosmo.sgi.com" + "\n");
    }
  }
  
  public void callback(EventOut event, double time, Object userData) {
    if (parent.Master)
      parent.resetBoard();
    else
      parent.output.appendText("Only the master can restart the game" + "\n");
  }  
  
}

class listWindow extends List {
  Chess chess;
  public listWindow(Chess c, Vector v) {
    super(2, false);
    chess = c;
    for (int i = 0; i < v.size(); i++) {
      if (chess.me.equals((String)v.elementAt(i)) == false)
	addItem((String)v.elementAt(i));
    }
  }
  
  public boolean action (Event e, Object o) {
    if (e.target == this) {
      chess.output.appendText("Your opponent is " +
			      (String)o + "." + "\n");
      chess.selectOpponent((String)o);
    }
    return true;
  }
}









